Index: trunk/cmake-modules/FlairUseFile.cmake
===================================================================
--- trunk/cmake-modules/FlairUseFile.cmake	(revision 25)
+++ trunk/cmake-modules/FlairUseFile.cmake	(revision 26)
@@ -103,2 +103,22 @@
 endif()
 
+#check if we have a flair-hds directory
+if (IS_DIRECTORY $ENV{FLAIR_ROOT}/flair-hds )
+	message("found flair-hds directory")
+	SET(FLAIRHDS_LIBRARY_DIR
+		$ENV{FLAIR_ROOT}/flair-hds/bin/lib/${ARCH_DIR}
+	)	
+
+	if(FLAIR_USE_FILTER)
+		SET(FLAIR_INCLUDE_DIR ${FLAIR_INCLUDE_DIR} $ENV{FLAIR_ROOT}/flair-hds/dev/include/VisionFilter)
+		SET(FLAIR_LIBRARIES_NRT ${FLAIRHDS_LIBRARY_DIR}/libVisionFilter.a ${FLAIRHDS_LIBRARY_DIR}/libdspcv_gpp.a ${FLAIR_LIBRARIES_NRT})
+		SET(FLAIR_LIBRARIES_RT ${FLAIRHDS_LIBRARY_DIR}/libVisionFilter.a ${FLAIRHDS_LIBRARY_DIR}/libdspcv_gpp.a ${FLAIR_LIBRARIES_RT})
+	endif()
+
+	if(FLAIR_USE_META AND "${CMAKE_SYSTEM_PROCESSOR}" MATCHES "arm")	
+		SET (ARDRONE2_LIB -Wl,--whole-archive ${FLAIRHDS_LIBRARY_DIR}/libFlairArdrone2.a -Wl,--no-whole-archive)
+		set(FLAIR_LIBRARIES_NRT ${ARDRONE2_LIB}  ${FLAIR_LIBRARIES_NRT} nmea)
+		SET(FLAIR_LIBRARY_DIR 	${FLAIR_LIBRARY_DIR} $ENV{FLAIR_ROOT}/flair-hds/bin/lib/${ARCH_DIR})
+
+	endif()
+endif()
Index: trunk/doc/Flair/classflair_1_1sensor_1_1_emulated_controller.js
===================================================================
--- trunk/doc/Flair/classflair_1_1sensor_1_1_emulated_controller.js	(revision 26)
+++ trunk/doc/Flair/classflair_1_1sensor_1_1_emulated_controller.js	(revision 26)
@@ -0,0 +1,30 @@
+var classflair_1_1sensor_1_1_emulated_controller =
+[
+    [ "ButtonType", "classflair_1_1sensor_1_1_emulated_controller.html#af77e801a251ecc3f5e4a46fb55eaf051", [
+      [ "start", "classflair_1_1sensor_1_1_emulated_controller.html#af77e801a251ecc3f5e4a46fb55eaf051aea2b2676c28c0db26d39331a336c6b92", null ],
+      [ "select", "classflair_1_1sensor_1_1_emulated_controller.html#af77e801a251ecc3f5e4a46fb55eaf051a99938282f04071859941e18f16efcf42", null ],
+      [ "square", "classflair_1_1sensor_1_1_emulated_controller.html#af77e801a251ecc3f5e4a46fb55eaf051a2fc01ec765ec0cb3dcc559126de20b30", null ],
+      [ "triangle", "classflair_1_1sensor_1_1_emulated_controller.html#af77e801a251ecc3f5e4a46fb55eaf051acef44b46f16ae8ecf664df4266ffdbf9", null ],
+      [ "circle", "classflair_1_1sensor_1_1_emulated_controller.html#af77e801a251ecc3f5e4a46fb55eaf051a9b6ddeba5b33e577c07c35d8505c6072", null ],
+      [ "cross", "classflair_1_1sensor_1_1_emulated_controller.html#af77e801a251ecc3f5e4a46fb55eaf051a22aadb26447d87b550b155a4d764fad0", null ],
+      [ "left1", "classflair_1_1sensor_1_1_emulated_controller.html#af77e801a251ecc3f5e4a46fb55eaf051a865da0aefc6b53ec8a0d6cecd5379daa", null ],
+      [ "left2", "classflair_1_1sensor_1_1_emulated_controller.html#af77e801a251ecc3f5e4a46fb55eaf051a7f034d1c5023a2e03223691748588744", null ],
+      [ "left3", "classflair_1_1sensor_1_1_emulated_controller.html#af77e801a251ecc3f5e4a46fb55eaf051a30eb555794194c4b6ddeca10fd17ecc0", null ],
+      [ "right1", "classflair_1_1sensor_1_1_emulated_controller.html#af77e801a251ecc3f5e4a46fb55eaf051a18818364f6b04334bbbebd28c364d6f6", null ],
+      [ "right2", "classflair_1_1sensor_1_1_emulated_controller.html#af77e801a251ecc3f5e4a46fb55eaf051afc77a875abf95303d340624306d94baf", null ],
+      [ "right3", "classflair_1_1sensor_1_1_emulated_controller.html#af77e801a251ecc3f5e4a46fb55eaf051a181f767dfd4b03074017d79ef4069c67", null ],
+      [ "up", "classflair_1_1sensor_1_1_emulated_controller.html#af77e801a251ecc3f5e4a46fb55eaf051a46c48bec0d282018b9d167eef7711b2c", null ],
+      [ "down", "classflair_1_1sensor_1_1_emulated_controller.html#af77e801a251ecc3f5e4a46fb55eaf051a74e8333ad11685ff3bdae589c8f6e34d", null ],
+      [ "left", "classflair_1_1sensor_1_1_emulated_controller.html#af77e801a251ecc3f5e4a46fb55eaf051a811882fecd5c7618d7099ebbd39ea254", null ],
+      [ "right", "classflair_1_1sensor_1_1_emulated_controller.html#af77e801a251ecc3f5e4a46fb55eaf051a7c4f29407893c334a6cb7a87bf045c0d", null ]
+    ] ],
+    [ "EmulatedController", "classflair_1_1sensor_1_1_emulated_controller.html#af7bcd67679646855b7f55b534621b004", null ],
+    [ "~EmulatedController", "classflair_1_1sensor_1_1_emulated_controller.html#ad7d6d2a52a2bc7c43d5cb9a571f3dc56", null ],
+    [ "AddStep", "classflair_1_1sensor_1_1_emulated_controller.html#a2be58f7c5552d77ca993f1347a600731", null ],
+    [ "IsConnected", "classflair_1_1sensor_1_1_emulated_controller.html#a67125a07c47f1e549ccb28df4622c2cf", null ],
+    [ "ProcessMessage", "classflair_1_1sensor_1_1_emulated_controller.html#a9b2f55fb43ce63e4d7521283408654f5", null ],
+    [ "IsDataFrameReady", "classflair_1_1sensor_1_1_emulated_controller.html#a410a9b4cb3ba86ad93e68d38bcfa8d36", null ],
+    [ "AcquireAxisData", "classflair_1_1sensor_1_1_emulated_controller.html#a514f48570872367dda335557be4696ef", null ],
+    [ "AcquireButtonData", "classflair_1_1sensor_1_1_emulated_controller.html#af4aab348140ae0c371f3ae7be5eaf5d9", null ],
+    [ "ControllerInitialization", "classflair_1_1sensor_1_1_emulated_controller.html#aa15ea652018777ee12797cc4e632f53c", null ]
+];
Index: trunk/doc/Flair/navtreedata.js
===================================================================
--- trunk/doc/Flair/navtreedata.js	(revision 26)
+++ trunk/doc/Flair/navtreedata.js	(revision 26)
@@ -0,0 +1,42 @@
+var NAVTREE =
+[
+  [ "Flair", "index.html", [
+    [ "Namespaces", null, [
+      [ "Namespace List", "namespaces.html", "namespaces" ],
+      [ "Namespace Members", "namespacemembers.html", [
+        [ "All", "namespacemembers.html", null ],
+        [ "Functions", "namespacemembers_func.html", null ],
+        [ "Typedefs", "namespacemembers_type.html", null ]
+      ] ]
+    ] ],
+    [ "Classes", null, [
+      [ "Class List", "annotated.html", "annotated" ],
+      [ "Class Index", "classes.html", null ],
+      [ "Class Hierarchy", "hierarchy.html", "hierarchy" ],
+      [ "Class Members", "functions.html", [
+        [ "All", "functions.html", "functions_dup" ],
+        [ "Functions", "functions_func.html", "functions_func" ],
+        [ "Variables", "functions_vars.html", null ],
+        [ "Enumerations", "functions_enum.html", null ],
+        [ "Enumerator", "functions_eval.html", null ]
+      ] ]
+    ] ],
+    [ "Files", null, [
+      [ "File List", "files.html", "files" ]
+    ] ]
+  ] ]
+];
+
+var NAVTREEINDEX =
+[
+"_afro_bldc_8h.html",
+"_vrpn_object_8h_source.html",
+"classflair_1_1core_1_1_object.html#a2a6f0753cfcbf314ad7fa952bfe9bc67",
+"classflair_1_1core_1_1cvmatrix_1_1_type.html#acc31fd9031af918e3a94d04e0cd7c439",
+"classflair_1_1gui_1_1_layout_position.html#abfff9b4fd6670430e8bd94440370ee49",
+"classflair_1_1sensor_1_1_flash_led_message.html",
+"classflair_1_1sensor_1_1_vrpn_client.html#acf82bb30ed4753183a3ddb8758d4a3b6"
+];
+
+var SYNCONMSG = 'click to disable panel synchronisation';
+var SYNCOFFMSG = 'click to enable panel synchronisation';
Index: trunk/include/FlairMeta/UavFactory.h
===================================================================
--- trunk/include/FlairMeta/UavFactory.h	(revision 25)
+++ trunk/include/FlairMeta/UavFactory.h	(revision 26)
@@ -25,3 +25,6 @@
                             flair::filter::UavMultiplex *multiplex = NULL);
 
+void RegisterUavCreator(flair::meta::Uav*(*func)(flair::core::FrameworkManager *parent,
+                                   std::string uav_name, std::string uav_type,
+                                   flair::filter::UavMultiplex *multiplex));
 #endif // UAVFACTORY
Index: trunk/include/FlairSensorActuator/EmulatedController.h
===================================================================
--- trunk/include/FlairSensorActuator/EmulatedController.h	(revision 26)
+++ trunk/include/FlairSensorActuator/EmulatedController.h	(revision 26)
@@ -0,0 +1,76 @@
+//  created:    2015/04/14
+//  filename:   EmulatedController.h
+//
+//  author:     Gildas Bayard
+//              Copyright Heudiasyc UMR UTC/CNRS 7253
+//
+//  version:    $Id: $
+//
+//  purpose:    class that emulate a remote control.
+//              Typical use case: run a demo without any reliable communication channel
+//
+//
+/*********************************************************************/
+
+#ifndef EMULATEDCONTROLLER_H
+#define EMULATEDCONTROLLER_H
+
+#include <TargetController.h>
+#include <list>
+
+namespace flair {
+    namespace core {
+        class FrameworkManager;
+        class cvmatrix;
+    }
+    namespace gui {
+        class Tab;
+        class TabWidget;
+        class DataPlot1D;
+    }
+}
+
+namespace flair { namespace sensor {
+    /*! \class EmulatedController
+    *
+    * \brief Emulated remote control
+    *
+    */
+    class EmulatedController : public TargetController {
+    public:
+        EmulatedController(const core::FrameworkManager* parent,std::string name,uint8_t priority=0);
+        ~EmulatedController();
+        enum class ButtonType : uint16_t {
+            start=0x0001,select=0x0002,square=0x0004,triangle=0x0008,
+            circle=0x0010,cross=0x0020,left1=0x0040,left2=0x0080,
+            left3=0x0100,right1=0x0200,right2=0x0400,right3=0x0800,
+            up=0x1000,down=0x2000,left=0x4000,right=0x8000
+        };
+        void AddStep(unsigned int durationMs,std::string description,uint16_t buttonPressed, float leftAxisX, float leftAxisY, float rightAxisX, float rightAxisY);
+    protected :
+        bool IsConnected() const;
+        //controller state stuff
+        bool ProcessMessage(core::Message *msg);
+        bool IsDataFrameReady();
+        void AcquireAxisData(core::cvmatrix &axis); //responsible for getting the axis data from the hardware
+        void AcquireButtonData(core::cvmatrix &button); //responsible for getting the button data from the hardware
+        bool ControllerInitialization();
+
+    private:
+        enum class DataType { axis,button };
+        void ComputeControllerData(DataType dataType, core::cvmatrix &data);
+        template<typename T> void fillVectorNoMutex(core::cvmatrix &vector,T data[],unsigned int size);
+        void fillVectorNoMutex(core::cvmatrix &destination,core::cvmatrix &source,unsigned int size);
+        struct StepData {
+            unsigned int durationMs; //milliseconds
+            core::cvmatrix *axisData;
+            core::cvmatrix *buttonData;
+            std::string description;
+            void Print();
+        };
+        std::list<StepData> steps;
+    };
+
+}}
+
+#endif // EMULATEDCONTROLLER_H
Index: trunk/scripts/flair_compile_all.sh
===================================================================
--- trunk/scripts/flair_compile_all.sh	(revision 25)
+++ trunk/scripts/flair_compile_all.sh	(revision 26)
@@ -65,5 +65,5 @@
 }
 
-function compile_flair() {
+function compile_libs() {
 	for projects in FlairCore FlairSensorActuator FlairFilter FlairMeta FlairSimulator ; do
 		configure $FLAIR_ROOT/flair-src/lib $projects
@@ -71,4 +71,12 @@
 		cross_compile $FLAIR_ROOT/flair-src/lib $projects
 	done
+
+	if [ -d $FLAIR_ROOT/flair-hds ]; then
+		for projects in FlairArdrone2 VisionFilter; do
+			configure $FLAIR_ROOT/flair-hds/src/lib $projects
+		   	compile $FLAIR_ROOT/flair-hds/src/lib $projects
+			cross_compile $FLAIR_ROOT/flair-hds/src/lib $projects
+		done
+	fi
 }
 
@@ -83,7 +91,7 @@
 function compile_uav_and_simulator_demo() {
 	for projects in simulator uav; do
-		configure $FLAIR_ROOT/flair-src/demos/$1 $projects
-	   	compile $FLAIR_ROOT/flair-src/demos/$1 $projects
-		cross_compile $FLAIR_ROOT/flair-src/demos/$1 $projects
+		configure $1/$2 $projects
+	   	compile $1/$2 $projects
+		cross_compile $1/$2 $projects
 	done
 }
@@ -97,25 +105,15 @@
 
 	for projects in CircleFollower SimpleFleet; do
-		compile_uav_and_simulator_demo $projects
+		compile_uav_and_simulator_demo $FLAIR_ROOT/flair-src/demos $projects
 	done
 
+	if [ -d $FLAIR_ROOT/flair-hds ]; then
+		for projects in OpticalFlow; do
+			compile_uav_and_simulator_demo $FLAIR_ROOT/flair-hds/src/demos $projects
+		done
+	fi
+
 exit 0	
-	for projects in ex_opencv; do
-		configure $FLAIR_ROOT/uav_ex $projects
-	   	compile $FLAIR_ROOT/uav_ex $projects
-		cross_compile $FLAIR_ROOT/uav_ex $projects
-	done 
-
-	for projects in control simulator; do
-		configure $FLAIR_ROOT/uav_ex/ex_simulator_framework $projects
-	   	compile $FLAIR_ROOT/uav_ex/ex_simulator_framework $projects
-		cross_compile $FLAIR_ROOT/uav_ex/ex_simulator_framework $projects
-	done
-
-	for projects in simulator uav; do
-		configure $FLAIR_ROOT/uav_ex/demo_flotte_framework $projects
-	   	compile $FLAIR_ROOT/uav_ex/demo_flotte_framework $projects
-		cross_compile $FLAIR_ROOT/uav_ex/demo_flotte_framework $projects
-	done
+	
 
 	for projects in uav; do
@@ -145,5 +143,5 @@
 
 if [ "$answer" = "" ] || [ "$answer" = "y" ] || [ "$answer" = "Y" ]; then
-	compile_flair
+	compile_libs
 fi
 
